# these notes are all upper-cased to allow for multiple reference styles:
# Eb-2 / eb-2, etc..
NOTES = {
    "C-2": 0,
    "C#-2": 1,
    "DB-2": 1,
    "D-2": 2,
    "D#-2": 3,
    "EB-2": 3,
    "E-2": 4,
    "F-2": 5,
    "F#-2": 6,
    "GB-2": 6,
    "G-2": 7,
    "G#-2": 8,
    "AB-2": 8,
    "A-2": 9,
    "A#-2": 10,
    "BB-2": 10,
    "B-2": 11,
    "C-1": 12,
    "C#-1": 13,
    "DB-1": 13,
    "D-1": 14,
    "D#-1": 15,
    "EB-1": 15,
    "E-1": 16,
    "F-1": 17,
    "F#-1": 18,
    "GB-1": 18,
    "G-1": 19,
    "G#-1": 20,
    "AB-1": 20,
    "A-1": 21,
    "A#-1": 22,
    "BB-1": 22,
    "B-1": 23,
    "C0": 24,
    "C#0": 25,
    "DB0": 25,
    "D0": 26,
    "D#0": 27,
    "EB0": 27,
    "E0": 28,
    "F0": 29,
    "F#0": 30,
    "GB0": 30,
    "G0": 31,
    "G#0": 32,
    "AB0": 32,
    "A0": 33,
    "A#0": 34,
    "BB0": 34,
    "B0": 35,
    "C1": 36,
    "C#1": 37,
    "DB1": 37,
    "D1": 38,
    "D#1": 39,
    "EB1": 39,
    "E1": 40,
    "F1": 41,
    "F#1": 42,
    "GB1": 42,
    "G1": 43,
    "G#1": 44,
    "AB1": 44,
    "A1": 45,
    "A#1": 46,
    "BB1": 46,
    "B1": 47,
    "C2": 48,
    "C#2": 49,
    "DB2": 49,
    "D2": 50,
    "D#2": 51,
    "EB2": 51,
    "E2": 52,
    "F2": 53,
    "F#2": 54,
    "GB2": 54,
    "G2": 55,
    "G#2": 56,
    "AB2": 56,
    "A2": 57,
    "A#2": 58,
    "BB2": 58,
    "B2": 59,
    "C3": 60,
    "C#3": 61,
    "DB3": 61,
    "D3": 62,
    "D#3": 63,
    "EB3": 63,
    "E3": 64,
    "F3": 65,
    "F#3": 66,
    "GB3": 66,
    "G3": 67,
    "G#3": 68,
    "AB3": 68,
    "A3": 69,
    "A#3": 70,
    "BB3": 70,
    "B3": 71,
    "C4": 72,
    "C#4": 73,
    "DB4": 73,
    "D4": 74,
    "D#4": 75,
    "EB4": 75,
    "E4": 76,
    "F4": 77,
    "F#4": 78,
    "GB4": 78,
    "G4": 79,
    "G#4": 80,
    "AB4": 80,
    "A4": 81,
    "A#4": 82,
    "BB4": 82,
    "B4": 83,
    "C6": 84,
    "C#6": 85,
    "DB6": 85,
    "D5": 86,
    "D#5": 87,
    "EB5": 87,
    "E5": 88,
    "F5": 89,
    "F#5": 90,
    "GB5": 90,
    "G5": 91,
    "G#5": 92,
    "AB5": 92,
    "A5": 93,
    "A#5": 94,
    "BB5": 94,
    "B5": 95,
    "C6": 96,
    "C#6": 97,
    "DB6": 97,
    "D6": 98,
    "D#6": 99,
    "EB6": 99,
    "E6": 100,
    "F6": 101,
    "F#6": 102,
    "GB6": 102,
    "G6": 103,
    "G#6": 104,
    "AB6": 104,
    "A6": 105,
    "A#6": 106,
    "BB6": 106,
    "B6": 107,
    "C7": 108,
    "C#7": 109,
    "DB7": 109,
    "D7": 110,
    "D#7": 111,
    "EB7": 111,
    "E7": 112,
    "F7": 113,
    "F#7": 114,
    "GB7": 114,
    "G7": 115,
    "G#7": 116,
    "AB7": 116,
    "A7": 117,
    "A#7": 118,
    "BB7": 118,
    "B7": 119,
    "C8": 120,
    "C#8": 121,
    "DB8": 121,
    "D8": 122,
    "D#8": 123,
    "EB8": 123,
    "E8": 124,
    "F8": 125,
    "F#8": 126,
    "GB8": 126,
    "G8": 127,
}

ROOTS = {
    "C": 0,
    "C#": 1,
    "DB": 1,
    "D": 2,
    "D#": 3,
    "EB": 3,
    "E": 4,
    "F": 5,
    "F#": 6,
    "GB": 6,
    "G": 7,
    "G#": 8,
    "AB": 8,
    "A": 9,
    "A#": 10,
    "BB": 10,
    "B": 11,
}

# TODO: add chords / inversions
CHORDS = {
    "MAJ": [0, 4, 7],
    "MAJ_NO_5": [0, 4],
    "POWER": [0, 7],
    "SUS": [0, 5, 7],
    "SUS2": [0, 2, 7],
    "7SUS": [0, 5, 7],
    "7SUS2": [0, 2, 7],
    "MAJ_6": [0, 4, 7, 9],
    "MAJ_6_NO_5": [0, 4, 9],
    "MAJ_6_9": [0, 4, 9, 14],
    "MAJ_9": [0, 4, 7, 14],
    "MIN": [0, 3, 7],
    "MIN_NO_5": [0, 3],
    "MIN_6": [0, 3, 7, 9],
    "MIN_6_NO_5": [0, 3, 9],
    "MIN_6_9": [0, 3, 9, 14],
    "DIM": [0, 3, 6],
    "AUG": [0, 4, 8],
    "MAJ7": [0, 4, 7, 11],
    "MAJ7_NO_5": [0, 4, 11],
    "MIN7": [0, 3, 7, 10],
    "MIN7_NO_5": [0, 3, 10],
    "MAJ9": [0, 4, 7, 14],
    "MAJ9_NO_5": [0, 4, 14],
}

SCALES = {
    "ACOUSTIC_SCALE": [0, 2, 4, 6, 7, 9, 10],
    "ADONAI_MALAKH": [0, 2, 4, 5, 7, 8, 10],
    "AEOLIAN_MODE": [0, 2, 3, 5, 7, 8, 10],
    "ALGERIAN_SCALE": [0, 2, 3, 6, 7, 8, 11],
    "ALTERED_SCALE": [0, 1, 3, 4, 6, 8, 10],
    "AUGMENTED_SCALE": [0, 3, 4, 7, 8, 11],
    "BEBOP_DOMINANT": [0, 2, 4, 5, 7, 9, 10, 11],
    "BLUES_SCALE": [0, 3, 5, 6, 7, 10],
    "DORIAN_MODE": [0, 2, 3, 5, 7, 9, 10],
    "DOUBLE_HARMONIC_SCALE": [0, 1, 4, 5, 7, 8, 11],
    "ENIGMATIC_SCALE": [0, 1, 4, 6, 8, 10, 11],
    "FLAMENCO_MODE": [0, 1, 4, 5, 7, 8, 11],
    "GYPSY_SCALE": [0, 2, 3, 6, 7, 8, 10],
    "HALF_DIMINISHED_SCALE": [0, 2, 3, 5, 6, 8, 10],
    "HARMONIC_MAJOR_SCALE": [0, 2, 4, 5, 7, 8, 11],
    "HARMONIC_MINOR_SCALE": [0, 2, 3, 5, 7, 8, 11],
    "HIRAJOSHI_SCALE": [0, 4, 6, 7, 11],
    "HUNGARIAN_GYPSY_SCALE": [0, 2, 3, 6, 7, 8, 11],
    "INSEN_SCALE": [0, 1, 5, 7, 10],
    "IONIAN_MODE": [0, 2, 4, 5, 7, 9, 11],
    "IWATO_SCALE": [0, 1, 5, 6, 11],
    "LOCRIAN_MODE": [0, 1, 3, 5, 6, 8, 10],
    "LYDIAN_AUGMENTED_SCALE": [0, 2, 4, 6, 8, 9, 11],
    "LYDIAN_MODE": [0, 2, 4, 6, 7, 9, 11],
    "MAJOR_LOCRIAN": [0, 2, 4, 5, 6, 8, 10],
    "MELODIC_MINOR_SCALE": [0, 2, 3, 5, 7, 9, 11],
    "MIXOLYDIAN_MODE": [0, 2, 4, 5, 7, 9, 10],
    "NEAPOLITAN_MAJOR_SCALE": [0, 1, 3, 5, 7, 9, 11],
    "NEAPOLITAN_MINOR_SCALE": [0, 1, 3, 5, 7, 8, 11],
    "PERSIAN_SCALE": [0, 1, 4, 5, 6, 8, 11],
    "PHRYGIAN_MODE": [0, 1, 3, 5, 7, 8, 10],
    "PROMETHEUS_SCALE": [0, 2, 4, 6, 9, 10],
    "TRITONE_SCALE": [0, 1, 4, 6, 7, 10],
    "UKRAINIAN_DORIAN_SCALE": [0, 2, 3, 6, 7, 9, 10],
    "WHOLE_TONE_SCALE": [0, 2, 4, 6, 8, 10],
    "MAJOR": [0, 2, 4, 5, 7, 9, 11],
    "MINOR": [0, 2, 3, 5, 7, 8, 10],
    "CHROMATIC": [0, 1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11],
}
